From f72cc54402dbf051c52657e843c9525c1aea972c Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Thu, 7 Mar 2019 16:23:34 -0800
Subject: [PATCH v20 2/2] tableam: Add insert, delete, update, lock_tuple.

Author:
Reviewed-By:
Discussion: https://postgr.es/m/
Backpatch:
---
 contrib/pgrowlocks/pgrowlocks.c               |   6 +-
 src/backend/access/heap/heapam.c              | 395 +++++++---------
 src/backend/access/heap/heapam_handler.c      | 324 +++++++++++++
 src/backend/access/heap/heapam_visibility.c   | 105 +++--
 src/backend/access/heap/tuptoaster.c          |   2 +-
 src/backend/access/table/tableam.c            | 113 +++++
 src/backend/access/table/tableamapi.c         |  13 +
 src/backend/commands/copy.c                   |   3 +-
 src/backend/commands/trigger.c                | 109 ++---
 src/backend/executor/execIndexing.c           |   4 +-
 src/backend/executor/execMain.c               | 289 +-----------
 src/backend/executor/execReplication.c        | 137 +++---
 src/backend/executor/nodeLockRows.c           | 137 ++----
 src/backend/executor/nodeModifyTable.c        | 424 ++++++++++--------
 src/backend/executor/nodeTidscan.c            |   2 +-
 src/include/access/heapam.h                   |  58 +--
 src/include/access/tableam.h                  | 347 ++++++++++++++
 src/include/executor/executor.h               |  12 +-
 src/include/nodes/lockoptions.h               |   5 +
 src/include/utils/snapshot.h                  |  13 -
 .../expected/partition-key-update-1.out       |   2 +-
 src/tools/pgindent/typedefs.list              |   4 +-
 22 files changed, 1465 insertions(+), 1039 deletions(-)

diff --git a/contrib/pgrowlocks/pgrowlocks.c b/contrib/pgrowlocks/pgrowlocks.c
index 2d2a6cf1533..54514309091 100644
--- a/contrib/pgrowlocks/pgrowlocks.c
+++ b/contrib/pgrowlocks/pgrowlocks.c
@@ -146,7 +146,7 @@ pgrowlocks(PG_FUNCTION_ARGS)
 	/* scan the relation */
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		HTSU_Result htsu;
+		TM_Result	htsu;
 		TransactionId xmax;
 		uint16		infomask;
 
@@ -160,9 +160,9 @@ pgrowlocks(PG_FUNCTION_ARGS)
 		infomask = tuple->t_data->t_infomask;
 
 		/*
-		 * A tuple is locked if HTSU returns BeingUpdated.
+		 * A tuple is locked if HTSU returns BeingModified.
 		 */
-		if (htsu == HeapTupleBeingUpdated)
+		if (htsu == TableTupleBeingModified)
 		{
 			char	  **values;
 
